> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/api-reference/storage-and-backup/network-file-storage/clusters/create-cluster.md).

# Create Cluster

Creates a new Cluster. The full Cluster needs to be provided to create the object. Optional data will be filled with defaults or left empty.

```json
{"openapi":"3.0.3","info":{"title":"IONOS CLOUD - Network File Storage API","version":"0.1.6"},"tags":[{"name":"Clusters","description":"Network File Storage cluster\nThis tag groups all operations for clusters.\n"}],"servers":[{"url":"https://nfs.de-fra.ionos.com","description":"service endpoint for location de-fra"},{"url":"https://nfs.de-txl.ionos.com","description":"service endpoint for location de-txl"},{"url":"https://nfs.es-vit.ionos.com","description":"service endpoint for location es-vit"},{"url":"https://nfs.fr-par.ionos.com","description":"service endpoint for location fr-par"},{"url":"https://nfs.gb-lhr.ionos.com","description":"service endpoint for location gb-lhr"},{"url":"https://nfs.us-ewr.ionos.com","description":"service endpoint for location us-ewr"},{"url":"https://nfs.us-las.ionos.com","description":"service endpoint for location us-las"},{"url":"https://nfs.us-mci.ionos.com","description":"service endpoint for location us-mci"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"ClusterCreate":{"type":"object","required":["properties"],"properties":{"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/Cluster"}}},"Cluster":{"type":"object","description":"Network File Storage cluster\n","required":["name","connections"],"properties":{"name":{"type":"string","description":"Name of the cluster"},"connections":{"type":"array","items":{"type":"object","required":["datacenterId","ipAddress","lan"],"properties":{"datacenterId":{"type":"string","format":"uuid","description":"The ID of the datacenter where the Network File Storage cluster is located.\n"},"lan":{"type":"string","description":"The LAN to which the Network File Storage cluster must be connected.\n"},"ipAddress":{"type":"string","description":"The IP address and prefix of the Network File Storage cluster. Must be specified in CIDR notation. Both IPv4 and IPv6 addresses are supported.\n"}}},"minItems":1,"maxItems":1},"nfs":{"type":"object","properties":{"minVersion":{"type":"string","description":"The minimum version of the NFS protocol.\n* `4.2` - NFSv4.2\n","default":"4.2"}}},"size":{"type":"integer","description":"The size of the Network File Storage cluster in TiB or GiB. Note that the cluster size cannot be reduced after provisioning.\nThis value determines the billing fees.\n- When `sizeUnit` is `TiB`, the allowed values are between 2 and 42.\n- When `sizeUnit` is `GiB`, the allowed values are between 2048 and 43008.\n","default":2},"sizeUnit":{"type":"string","description":"The type of the size for the Network File Storage cluster which can be TiB or GiB.","default":"TiB"}}},"ClusterRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Cluster.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["cluster"]},"href":{"description":"The URL of the Cluster.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithUsage"},"properties":{"$ref":"#/components/schemas/Cluster"}}},"MetadataWithUsage":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["used"],"properties":{"used":{"type":"integer","format":"int64","description":"The storage capacity currently taken up by the customer's files in bytes, or 0 on error.\n","readOnly":true}}}]},"MetadataWithStatus":{"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["status"],"properties":{"status":{"type":"string","description":"The status of the resource can be one of the following:\n* `AVAILABLE` - The resource exists and is healthy.\n* `PROVISIONING` - The resource is being created or updated.\n* `DESTROYING` - A delete command was issued, and the resource is being deleted.\n* `FAILED` - The resource failed, with details provided in `statusMessage`.\n","enum":["PROVISIONING","DESTROYING","AVAILABLE","FAILED"],"readOnly":true},"statusMessage":{"type":"string","description":"The error message when the status is `FAILED`.\n","readOnly":true}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/clusters":{"post":{"operationId":"clustersPost","summary":"Create Cluster","tags":["Clusters"],"description":"Creates a new Cluster.\nThe full Cluster needs to be provided to create the object.\nOptional data will be filled with defaults or left empty.\n","requestBody":{"description":"Cluster to create.","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClusterCreate"}}}},"responses":{"201":{"description":"Cluster successfully created.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClusterRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ionos.com/cloud/api-reference/storage-and-backup/network-file-storage/clusters/create-cluster.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
